<?xml version='1.0' encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:m="http://www.w3.org/1998/Math/MathML"
  version='1.0'>
  <xsl:template match="m:menclose">
    <xsl:call-template name="menclose-start">
      <xsl:with-param name="notation" select="@notation"/>
    </xsl:call-template>
    <xsl:apply-templates/>
    <xsl:call-template name="menclose-end">
      <xsl:with-param name="notation" select="@notation"/>
    </xsl:call-template>
  </xsl:template>

  <xsl:template name="menclose-start">
    <xsl:param name="notation"/>
    <xsl:choose>
    <xsl:when test="$notation = 'box' or $notation = 'roundedbox'">\boxed{</xsl:when>
    <xsl:when test="$notation = 'updiagonalstrike'">\cancel{</xsl:when>
    <xsl:when test="$notation = 'downdiagonalstrike'">\bcancel{</xsl:when>
    <xsl:when test="$notation = 'updiagonalarrow'">\cancelto{</xsl:when>
    <xsl:when test="$notation = 'top'">\overline{</xsl:when>
    <xsl:when test="$notation = 'underline'">\underline{</xsl:when>
    <xsl:when test="$notation = 'left'">\left|</xsl:when>
    <xsl:when test="$notation = 'right'">\left.{</xsl:when>
    <xsl:when test="$notation = 'radical'">\sqrt{</xsl:when>
    <xsl:otherwise>\<xsl:value-of select="$notation" />{</xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="menclose-end">
    <xsl:param name="notation"/>
    <xsl:choose>
    <xsl:when test="$notation = 'left'">\right.</xsl:when>
    <xsl:when test="$notation = 'right'">}\right|</xsl:when>
    <xsl:otherwise>}</xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
