<?xml version='1.0' encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:m="http://www.w3.org/1998/Math/MathML"
  version='1.0'>
  <xsl:template match="m:mfenced">
    <xsl:choose>
      <xsl:when test="@open">
        <xsl:text>\left</xsl:text>
        <xsl:if test="@open='{' or @open='}'"><xsl:text>\</xsl:text></xsl:if>
        <xsl:choose>
          <xsl:when test="@open='||'">\|</xsl:when>
          <xsl:when test="@open='&lt;'">\langle</xsl:when>
          <xsl:when test="@open=''">.</xsl:when>
          <xsl:otherwise><xsl:value-of select="@open"/></xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise><xsl:text>\left(</xsl:text></xsl:otherwise>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="count(./*)>1">
        <xsl:variable name="symbol">
          <xsl:choose>
            <xsl:when test="@separators">
              <xsl:call-template name="startspace">
                <xsl:with-param name="symbol" select="@separators"/>
              </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>,</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:for-each select="./*">
          <xsl:apply-templates select="."/>
          <xsl:if test="not(position()=last())">
            <xsl:choose>
              <xsl:when test="position()>string-length($symbol)">
                <xsl:value-of select="substring($symbol,string-length($symbol))"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="substring($symbol,position(),1)"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:if>
        </xsl:for-each>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="@close">
        <xsl:text>\right</xsl:text>
        <xsl:if test="@close='{' or @close='}'"><xsl:text>\</xsl:text></xsl:if>
        <xsl:choose>
          <xsl:when test="@close = ''">.</xsl:when>
          <xsl:when test="@close='||'">\|</xsl:when>
          <xsl:when test="@close='&gt;'">\rangle</xsl:when>
          <xsl:when test="@open=''">.</xsl:when>
          <xsl:otherwise><xsl:value-of select="@close"/></xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise><xsl:text>\right)</xsl:text></xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
