# frozen_string_literal: true

# provide regex operations to xslt
# regex is not available to xslt 1.0
require 'mathml2latex/symbols.rb'

module Mathml2latex
  class XsltFunctions
    def replace(str, regex_str, replacement)
      regex = Regexp.new(regex_str)
      str.gsub(regex, replacement)
    end

    def matches(str, regex_str, flag = '')
      str.downcase! if flag == 'i'
      regex = Regexp.new(regex_str)
      !(str =~ regex).nil?
    end

    def fetch_symbols(str)
      ret_str = ''.dup
      str.each_char do |character|
        key = character.chr.ord
        val = Mathml2latex::SYMBOLS[key]
        val = character if val.nil?
        ret_str << val
      end
      ret_str
    end
  end
end
